#pragma once

/**
* @ingroup Base Lib
* @brief	Array scope guard helper
* @date		07/17/2007
* @author	telltale
* @remark	
*/
template <class T>
class CNAutoBuffer
{
public:
	CNAutoBuffer() 
	{
		m_pBuf = NULL;
		m_dwBufLen = 0;
	}
	~CNAutoBuffer()
	{
		DestroyBuffer();
	}
	T*	Alloc(DWORD dwBufLen)
	{
		DestroyBuffer();
		m_pBuf = new T[dwBufLen];
		m_dwBufLen = dwBufLen;
		return m_pBuf;
	}
	T*	GetBuffer() { return m_pBuf; }
	DWORD	GetSize() { return m_dwBufLen; }
	T& operator[]( size_t iElement ) { return m_pBuf[iElement]; }
	void Free()
	{
		DestroyBuffer();
	}

private:
	///< destroy buffer
	void	DestroyBuffer()
	{
		if (m_pBuf)
		{
			delete[] m_pBuf;
			m_pBuf = NULL;
			m_dwBufLen = 0;
		}
	}
	///< buffer
	T*	m_pBuf;
	///< buffer length
	DWORD	m_dwBufLen;
};